/* buennoc.c -- A malloc() wrapper
   Copyright (C) 2003, 2004
   Arturo "Buanzo" Busleiman <buanzo@buanzo.com.ar> <buanzo@linux.org.ar>
   
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

#include <unistd.h>
#include <stdlib.h>
#include <string.h>

/* buennoc() allocates 'size' bytes and returns a pointer to the
allocated memory.  The memory is set to zero. 
If salir > 0 then it exit()s with a status of 127.
else it returns NULL if memory can't be allocated,
*/

void *
buennoc (size_t size, int salir)
{
  void *memry = NULL;

  memry = malloc (size);
  if (memry == NULL)
    {
      if (salir > 0)
	exit (127);
      else
	return (NULL);
    }
  else {
memset(memry,0,size);
    return (memry); 
    }
}
